import React from 'react'
import { HashRouter,Switch, Route, NavLink,Redirect} from 'react-router-dom';
import PropTypes from 'prop-types'
import DateTool from '@/util/DateTool'

import Book from '@/components/Book'
import User from '@/components/User'
import About from '@/components/About'
import Children from '@/components/Children'

const routes = {
  'uinfo':[
      {id:1,name:'用户','path':'/user'},
      {id:2,name:'书籍','path':'/book'}
  ],
  'others':[
    {id:3,name:'多级路由与全局state','path':'/children'},
    {id:4,name:'服务器数据交互','path':'/about'}
  ]
}
export default class App extends React.PureComponent {
  constructor(props){
    super(props)

    let rkey = 'uinfo',keymenus = routes[rkey];
    this.state = {
      count: 1,
      rkey: rkey,
      menus: keymenus
    };

    this.getClassN = this.getClassN.bind(this);
    this.changeMeus = this.changeMeus.bind(this);
  }
  get myDate () {
    return DateTool.formatDate(new Date());
  }
  changeMeus (key) {
    let keymenus = routes[key];
    this.setState({
      rkey: key,
      menus: keymenus
    });
  }
  getClassN (key) {
    if(this.state.rkey == key){
      return 'active';
    }
    else{
      return '';
    }
  }
  componentWillMount () {

  }
  componentDidMount  () {

  }
  componentWillUnmount () {

  }
  componentDidUpdate  (prevProps, prevState) {
    console.log(prevState,this.state)
  }
  render() {
    let navHtml = [{'name':'用户相关','key':'uinfo'},{'name':'其他','key':'others'}].map(menu => {
      return <a key={menu.key} href="javascript:void(0)" className={this.getClassN(menu.key)} onClick={() => {this.changeMeus(menu.key)}}>{menu.name}</a>;
    })

    let menuCont = this.state.menus.map(item => {
      return <li key={item.id}><NavLink to={item.path}>{item.name}</NavLink></li>
    });

    let defaultTo = this.state.menus[0].path;

    return (<HashRouter>
            <div className="mainbody">
              <header>
                <nav>{navHtml}</nav>
              </header>
              <div className="contentWrap">
                <div className="leftNav">
            			<ul>{menuCont}</ul>
            		</div>
            		<div className="rightCont">
                  {this.myDate}
                  <Switch>
                    <Route path="/user" component={User}></Route>
                    <Route path="/book" component={Book}></Route>
                    <Route path="/children" component={Children}></Route>
                    <Route path="/about" component={About}></Route>
                    <Redirect to={defaultTo}/>
                  </Switch>
            		</div>
              </div>
            </div>
          </HashRouter>)
  }
}
App.defaultProps = {
  name: 'kaka'
}
App.propTypes = {
  name: PropTypes.string.isRequired
}
